<%'------------------------------------------------------------------------------------------
'-  WEB Calendar Application - Version 3.6 - 01 august 2008 
'-  Copyright  2005-2008 - Livio Siri (http://www.livio.net) - All Rights Reserved.     
'----------------------------------------------------------------------------------------------
'=== Common Functions and Subs ============================

'---  Common Init ------------------------------------------------------
Sub Common_Init()
	'--- database type related connection
	If LCase(dbType) = "access" Then
		If request.servervariables("HTTP_HOST") = "127.0.0.1" OR request.servervariables("HTTP_HOST") = "localhost" then dbCalPath = dBCalLocalPath Else dbCalPath = dbCalRemotePath End if
		sCalendarDSN = dbCalendarConnOLE & dbCalPath & dBCalendar & ";"
	Elseif LCase(dbType) = "mssql" Then
		sCalendarDSN = dbMSSQLCalendarConnOLE
	Elseif LCase(dbType) = "mysql" Then
		sCalendarDSN = dbMySQLCalendarConnOLE
	End if

	'--- Select the locale ID date format
	Call SelectDateFormat()

	'--- read configuration from database
		Call ReadConfigDetails()

	'--- force enable HTML if WYSIWYG is on
	If bHTMLText Then bStripHTML = False

	'--- transform bProtect to boolean
	if vartype(bProtect) = 2 Then bProtect = CBool(bProtect) End if

	'--- allow everyone to administer if bProtect is off
	If NOT bProtect then Session("bLoginSuccessful") = True End if

	sCalendarPath = Request.ServerVariables("SCRIPT_NAME")
	
	'--- assign URL if custon event page
	If sCalendarEventsPage = "" Then sCalendarEventsPage = sCalendarPath End if

	'--- preserve user querystrings
	PreserveQueryString()
End Sub '--- Common_Init

'---- Check if the Calendar Array contains a field value ---------------------------
Function Onlist(StrField, TheArray)
	Dim count
	If isArray(TheArray) Then
		For count = LBound(TheArray) to UBound(TheArray)
			If lcase(StrField) = lcase(TheArray(Count)) Then
				Onlist = True
			End If
		Next
	End If
End Function '--- Onlist

'------ Preserve user QueryStrings ------------------------------------
Function PreserveQueryString()
	Dim aIgnoreList, field, count
	'--- Array of QueryStrings used inside Calendar routines
	aIgnoreList = Array("c", "CalendarMode", "Infomode", "CalDate", "CalMonth", "CalYear", "CalhWK", "Event_ID", "Event_Title", "Start_Date", "UpcomingEvents", "CalPage", "CalLogoff", "YearlyEvents", "Calendar", "CalLogin", "CalDelete", "Category_ID", "CatDelete", "Category_Detail", "Category", "sCategory", "refresh")
	'--- Check if a foreign QueryString value is passed to the calendar
	For i = 1 To Request.QueryString.Count
		if NOT Onlist(LCase(Request.QueryString.Key(i)), aIgnoreList) Then
			RQString = RQString & "&" & Server.URLEncode(Request.QueryString.Key(i)) & "=" & Server.URLEncode(Request.QueryString.Item(i))
		End if
	Next
	if Len(RQString) <> 0 Then
		'--- If foreign QueryString available then add it
		RQString = Mid(RQString, 2)
	Else
		'--- else add a dummy QueryString
		RQString = "dummy=dummy"
	End if
End Function '--- PreserveQueryString

'------- Select the locale ID date format ---------------------------------------------------
Sub SelectDateFormat()
	Dim ddDate, mmDate, yyDate, tdDate, tmDate, aDate, strDate
	ActualLCID = Session.LCID
	ddDate = trim(day(date))
	mmDate = trim(month(date))
	yyDate = trim(year(date))
	If ddDate = mmDate then
		tempDate = Date + 1
		ddDate = ddDate + 1
	Else
		tempDate = Date
	End if
	If instr(tempDate, "/") > 0 Then
		aDate = split(tempdate, "/", -1, 1)
	ElseIf instr(tempDate, "-") > 0 Then
		aDate = split(tempdate, "-", -1, 1)
	ElseIf instr(tempDate, ".") > 0 Then
		aDate = split(tempdate, ".", -1, 1)
	End if
	If Len(ddDate) = 1 Then ddDate = "0" & ddDate End if
	If Len(mmDate) = 1 Then mmDate = "0" & mmDate End if
	If Len(aDate(0)) = 1 Then aDate(0) = "0" & aDate(0) End if
	If Len(aDate(1)) = 1 Then aDate(1) = "0" & aDate(1) End if
	'--- bInternational: False=MM/DD/YYYY, True=DD/MM/YYYY
	if cstr(ddDate) = cstr(aDate(0)) AND cstr(mmDate) = cstr(aDate(1)) AND yyDate = aDate(2) Then bInternational = True Else bInternational = False End if
End Sub '--- SelectDateFormat

'------- Select Week Type ---------------------------------------------------------------
Function SelectWeekType(vDate)
	Dim intWeek
	'--- Select your week number presentation:
	Select Case sWeekType
		Case "vbUseSystem"
			intWeek = DatePart("ww", DateValue(vDate), vbUseSystem, vbUseSystem) '--- Use National Language Support (NLS) API setting.
		Case "vbFirstJan1"
			intWeek = DatePart("ww", DateValue(vDate), vbUseSystem, vbFirstJan1) '--- Start with the week in which January 1 occurs.
		Case "vbFirstFourDays"
			intWeek = DatePart("ww", DateValue(vDate), vbUseSystem, vbFirstFourDays) '--- Start with the week that has at least four days in the new year. (ISO 8601)
		Case "vbFirstFullWeek"
			intWeek = DatePart("ww", DateValue(vDate), vbUseSystem, vbFirstFullWeek) '--- Start with the first full week of the new year.
	End Select
	SelectWeekType = intWeek
End Function '--- SelectWeekType

'----- Response.Write replacer -----------------------------------------------------------------
Sub W(Str)
  Response.Write(Str & Vbcrlf)
End Sub

'----- Response.End replacer -----------------------------------------------------------------
Sub re()
  Response.End
End Sub

'----------Read or update the configuration in the database ----------------------------------------------------------
Sub ReadConfigDetails()
	Dim strConfigSQL, bField, sDB, sDBerr
	Dim Field, T_Item, sCSQL, sSQL
	strCalModeConfig = Request.Form("UpdateConfig")
	sTable = "tblConfig"
	Set RS = Server.CreateObject("ADODB.Recordset")
	strConfigSQL = "SELECT * FROM " & sTable & " WHERE ID = 0"
	On error resume next
	RS.Open strConfigSQL, sCalendarDSN, adOpenStatic, adLockOptimistic, adCmdText
		If NOT RS.EOF Then
			'--- Read in the config details from the recordset
			Call Config_Details()
			'--- Do edit/update configuration
			If strCalModeConfig = "ChangeConfig" Then	
				Call GetFormFields()
				RS.Find "ID=0"
				Call BuildFieldUpdate()
				'--- Store data
				sSQL = "UPDATE " & sTable & " SET " & upString & " WHERE ID LIKE '0'"
				Call ExecutesSQL(sSQL)
			End If
		End If
		RS.Close
		RS.Open strConfigSQL, sCalendarDSN, adOpenStatic, adLockOptimistic, adCmdText
			'--- If an error has occured write an error to the page
		If Err.Number <> 0 Then
			If LCASE(DbType) = "mysql"  Then
				sDB = sMySQLDBName
				sDBerr = "Click here: <a href=""" & sScriptDir & "Build_Database.asp?ref=http://" & Request.ServerVariables("HTTP_HOST") & Request.ServerVariables("SCRIPT_NAME") & "&dbType=" & dbType & """>Build_MySQL_database</a><br />to create a new MySQL Calendar database"
			ElseIf LCASE(DbType) = "mssql"  Then
				sDB = sMSSQLDBName
				sDBerr = "Click here: <a href=""" & sScriptDir & "Build_Database.asp?ref=http://" & Request.ServerVariables("HTTP_HOST") & Request.ServerVariables("SCRIPT_NAME") & "&dbType=" & dbType & """>Build_MSSQL_database</a><br />to create the MSSQL Calendar database"
			Else
				sDB = dBCalendar
			End if
			W "<table cellspacing='0' cellpadding='5' align='center' style=""border-left: outset 1px;border-top: outset 1px;"" border='0'><tbody>"
			w "<tr><td height='20' align='middle' bgcolor=""#f0f0f0"" colspan='2' style=""border-right: outset 1px;border-bottom:outset 1px;""><br />"
			W "<div align='center' style=""font-family:verdana; font-weight:normal;font-size:12px;"">Error the database <B>" & sDB & "</B> does not exist on Server<br />"
			W Err.description & "<br /><br />"
			W sDBerr & "</div>"
			W "<br /></td></tr></table>"
			'--- Reset error object
			Err.Number = 0
			re
		End If

		If NOT RS.EOF Then
			'--- Read in the updated config details from the recordset
			Call Config_Details
		End If
	'--- Reset Server Objects
	RS.Close

	On error goto 0
	Set RS = Nothing
End Sub '--- ReadConfigDetails

'------- Store Configuration into variables ----------------------------------------------
Sub Config_Details()
'	On Error Resume next
	sUsername = RS("sUsername")
	sPassword = RS("sPassword")
	bProtect = BoolValue(RS("bProtect"))
	bGuest = BoolValue(RS("bGuest"))
	bCheckGuest = BoolValue(RS("bCheckGuest"))
	bShowCalendar = BoolValue(RS("bShowCalendar"))
	bEventsPopUp = BoolValue(RS("bEventsPopUp"))
	bEventsPopUpYearly = BoolValue(RS("bEventsPopUpYearly"))
	bEventsPopUpCategory = BoolValue(RS("bEventsPopUpCategory"))
	bEventsPopUpUpcoming = BoolValue(RS("bEventsPopUpUpcoming"))
	intPopUpWidth = RS("intPopUpWidth")
	intPopUpHeight = RS("intPopUpHeight")
	bUpcomingEvents = BoolValue(RS("bUpcomingEvents"))
	intUpcomingEvents = RS("intUpcomingEvents")
	bFilterEvents = BoolValue(RS("bFilterEvents"))
	bYearlyEvents = BoolValue(RS("bYearlyEvents"))
	bQuarterly = BoolValue(RS("bQuarterly"))
	bWeekColumn = BoolValue(RS("bWeekColumn"))
	sWeekType = RS("sWeekType")
	bHTMLText = BoolValue(RS("bHTMLText"))
	bStripHTML = BoolValue(RS("bStripHTML"))
	bEventDelete = BoolValue(RS("bEventDelete"))
	bEventEditorName = BoolValue(RS("bEventEditorName"))
	bEmailer = BoolValue(RS("bEmailer"))
	intEmailDays = RS("intEmailDays")
	sFrom = RS("sFrom")
	sAdministratorsEmail = RS("sAdministratorsEmail")
	sMailRecipient = RS("sMailRecipient")
	sMailRecipientBCC = RS("sMailRecipientBCC")
	sMailObject = RS("sMailObject")
	sMailServerAddress = RS("sMailServerAddress")
	sFormat = RS("sFormat")
	sEventTitleBGColor = RS("sEventTitleBGColor")
	sEventTitleForeColor = RS("sEventTitleForeColor")
	sEventWindowBGColor = RS("sEventWindowBGColor")
	bBorderDays = BoolValue(RS("bBorderDays"))
	bEvent_Repeat = BoolValue(RS("bEvent_Repeat"))
	sSort_Dir = RS("sSort_Dir")
	If Request.Querystring("CalhWK") = "ok" Then Session("bWK") = True End if
	If Err.number <> 0 Then
		w "<B STYLE=""color:crimson;"">ERROR NUMBER:</b> (" & Hex(Err.number) & ")<br />"
		w "<B STYLE=""color:crimson;"">ERROR SOURCE:</b> (" & Err.source & ")<br />"
		w "<B STYLE=""color:crimson;"">ERROR DESCRIPTION:</b> (" & Err.description & ")</span><br />"
		W "ERROR: probably your Calendar Database is not updated to the last version<br />"
	re
	End if
'	On Error goto 0
End Sub '--- Config_Details

'---------- Transform MySQL boolean values ----------------------------------------------------------
Function BoolValue(bValue)
	Dim bTemp
	If LCase(dbType) = "mysql" OR LCase(dbType) = "mssql" Then
		If bValue <> 1 Then
			bValue = False
		Else
			bValue = True
		End if
	End if
	BoolValue = bValue
End Function '--- BoolValue

'----------Read or update category configuration in the database ----------------------------------------------------------
Sub ReadCategoryDetails()
	Dim strCategorySQL, sCategory(), intRows, sCSQL, sTable
	sTable = "tblCategory"
	strCatModeConfig = Request.Form("UpdateCategory")
	Set rsCatConfigDetails = Server.CreateObject("ADODB.Recordset")

		If strCatModeConfig = "EditCategory" Then	'--- EDIT
			strCategorySQL = "SELECT * FROM " & sTable
			rsCatConfigDetails.Open strCategorySQL, sCalendarDSN, adOpenStatic, adLockReadOnly, adCmdText
			'--- Get RecordCount value
			On error resume next
				intRows = rsCatConfigDetails.GetRows
				rsCatConfigDetails.MoveFirst
				rsCatRC = UBound(intRows, 2) + 1
			On error goto 0
			If rsCatRC <> 0 Then
				'--- Read in the category details from the recordset
				For i = 1 to rsCatRC
					REDIM PRESERVE sCategory(1, i)
					sCategory(0, i) = rsCatConfigDetails("Category_ID")
					sCategory(1, i) = rsCatConfigDetails("sCategory")
					rsCatConfigDetails.MoveNext
				Next
				rsCatConfigDetails.Close
			End If
				'--- Update category
				For i = 1 to rsCatRC
					strCategorySQL = "SELECT * FROM " & sTable & " WHERE Category_ID = " & sCategory(0, i)
					rsCatConfigDetails.Open strCategorySQL, sCalendarDSN, adOpenKeySet, adLockPessimistic, adCmdText
					'--- Store data
					sCSQL = "UPDATE " & sTable & " SET sCategory='" & Request.form("" & sCategory(1, i) & "") & "' WHERE Category_ID = " & sCategory(0, i)
					Call ExecutesSQL(sCSQL)
					rsCatConfigDetails.Close
				Next

		ElseIf strCatModeConfig = "AddCategory" Then '--- ADD
			'--- Add category
				'--- Get form fields
				Call GetFormFields()
				If Request.Form("sCategory") <> "" Then
					'--- Build fields and values
					sSQL = 	"SELECT * FROM " & sTable
					Set Rs = Server.CreateObject("ADODB.RecordSet")
					RS.Open sSQL, sCalendarDSN, adOpenStatic, adLockOptimistic, adCmdText
							Call BuildFieldUpdate()
					Rs.Close
					Set RS = Nothing
					'--- Store data
					sSQL = "INSERT INTO " & sTable & " (" & upFields & ") VALUES (" & upValues & ")"
					Call ExecutesSQL(sSQL)
				Else
					W "<span style=""font-size:12px;"">Field is empty!</span>"
				End if
		End if

		If rsCatConfigDetails.State = &H00000001 then
			rsCatConfigDetails.Close
		End if
			'--- Requery updated category details from the recordset
			strCategorySQL = "SELECT * FROM " & sTable & " ORDER BY sCategory ASC;"
			rsCatConfigDetails.Open strCategorySQL, sCalendarDSN, adOpenStatic, adLockReadOnly, adCmdText
			'--- Get RecordCount value
				On error resume next
					intRows = rsCatConfigDetails.GetRows
					rsCatConfigDetails.MoveFirst
					rsCatRC = UBound(intRows, 2) + 1
				On error goto 0
				If rsCatRC <> 0 Then
					For i = 1 to rsCatRC
						REDIM PRESERVE sCategory(1, i)
						sCategory(0, i) = rsCatConfigDetails("Category_ID")
						sCategory(1, i) = rsCatConfigDetails("sCategory")
						W "<tr><td valign='top' align='left' style=""border-bottom:1px solid " & sEventTitleBGColor & ";"" nowrap='nowrap'"
						W "<input type='text' size='45' maxlength='100' name=""" & sCategory(1, i) & """ id=""" & sCategory(1, i) & """ value=""" & sCategory(1, i) & """ class='cal' /></td>"
						If bEventDelete Then
							W "<td valign='top' bgcolor='#F0F0F0' align='center' style=""border-bottom: 1px solid " & sEventTitleBGColor & ";font-size:12px;padding-left:2px;"" nowrap='nowrap'>["
							W "<a href=""" & sFileName & "?" & RQString & "&amp;CalendarMode=DELETECATEGORY&amp;Category_ID=" & sCategory(0, i) & "&amp;Category_Detail='" & sCategory(1, i) & "'&amp;CalMonth=" & intThisMonth & "&amp;CalYear=" & intThisYear & """ title="" " & strDelCat & " "">"
							W "<img src=""" & strImgDir & "delete.gif"" border='0' height='11' width='16' style=""vertical-align: middle;border:none;padding-left:2px;padding-right:2px;""></a>]</td></tr>" 
						End if
						rsCatConfigDetails.MoveNext
					Next
					rsCatConfigDetails.Close
				End If
	'--- Reset Server Objects
	Set rsCatConfigDetails = Nothing
End Sub '--- ReadCategoryDetails

'------- Sort Array values by column and choose sort direction --------------------------
Function SortArray(values(), intSortCol, sSort_Dir)
	Dim i 
	Dim j 
	Dim value 
	Dim value_j 
	dim min
	dim max
	dim temp
	dim datatype
	dim intComp
	dim intA
	dim intCheckIndex
	Dim strDirection
	strDirection = Left(sSort_Dir, 1)

	On Error Resume next
	min = lbound(values,2)
	max = ubound(values,2)
	  
	'--- check to see what direction you want to sort.
	'--- "d" = descending
	if lcase(strDirection) = "d" then
		intComp = -1
	else
		intComp = 1
	end if
	  
	if intSortCol < 0 or intSortCol > ubound(values,1) then
		arraysort = values
		exit function
	end if
	'--- find the first item which has valid data in it to sort
	intCheckIndex = min
	while len(trim(values(intSortCol,intCheckIndex))) = 0 and intCheckIndex < ubound(values,2)
		intCheckIndex = intCheckIndex + 1
	wend
	if isDate(trim(values(intSortCol,intCheckIndex))) then
		datatype = 1
	else
		if isNumeric(trim(values(intSortCol,intCheckIndex))) then
			datatype = 2
		else
			datatype = 0
		end if
	end if
	For i = min To max - 1
		value = values(intSortCol,i)
		value_j = i
		For j = i + 1 To max
			select case datatype
				case 0
					'--- See if values(j) is smaller. works with strings now.
					If strComp(values(intSortCol,j),value,vbTextCompare) = intComp Then
						'--- Save the new smallest value.
						value = values(intSortCol,j)
						value_j = j
					End If
				case 1
					if intComp = -1 then
						if DateDiff("s",values(intSortCol,j),value) > 0 then
							'--- Save the new smallest value.
							value = values(intSortCol,j)
							value_j = j
						end if
					else
						if DateDiff("s",values(intSortCol,j),value) < 0 then
							'--- Save the new smallest value.
							value = values(intSortCol,j)
							value_j = j
						end if
					end if
				case 2
					if intComp = -1 then
						if cdbl(values(intSortCol,j)) < cdbl(value) then
							'--- Save the new smallest value.
							value = values(intSortCol,j)
							value_j = j
						end if
					else
						if cdbl(values(intSortCol,j)) > cdbl(value) then
							'--- Save the new smallest value.
							value = values(intSortCol,j)
							value_j = j
						end if
					end if
			end select
		Next 'j
		If value_j <> i Then
			'--- Swap items i and value_j.
			for intA = 0 to ubound(values,1)
				temp = values(intA,value_j)
				values(intA,value_j) = values(intA,i)
				values(intA,i) = temp
			next '--- intA
		End If
	Next 'i
	SortArray = values
End Function

'--------- Select Date Type (MM/DD/YYYY, DD/MM/YYYY) ------------------------------------
Function LDate(myDay, myMonth, myYear, international)
	If international Then
		LDate = myDay & "/"& myMonth & "/" & myYear 
	Else
		LDate = myMonth & "/" & myDay & "/"& myYear
	End if 
End Function '--- LDate

'-------- Get Las Day of the month ----------------------------------------------------
Function GetLastDay(intMonthNum, intYearNum)
	Dim dNextStart
	If CInt(intMonthNum) = 12 Then
		dNextStart =  "1/1/" & intYearNum
	Else
		dNextStart = LDate("1", intMonthNum + 1, intYearNum, binternational)
	End If
	GetLastDay = Day(DateValue(dNextStart) - 1)
End Function '--- GetLastDay
	
'------ Turkish/Slovenian (or special) languages -----------------------------------------------------------------------
	sLanguage = UCase(strAcceptLanguage)

'------- Get Custom Month Name ---------------------------------------------------------------------
Function SpecialMonthName(intMonthNum, sLanguage)
	Dim arrMonth
	Select Case sLanguage
		Case "TR" '--- Turkish
			arrMonth = Array("Ocak", "Subat", "Mart", "Nisan", "Mayis", "Haziran", "Temmuz", "Agustos", "Eyll", "Ekim", "Kasim", "Aralik")
			SpecialMonthName = arrMonth(intMonthNum - 1)
		Case "SL" '--- Slovenian
			arrMonth = Array("januar", "februar", "marec", "april", "maj", "junij", "julij", "avgust", "september", "oktober", "november", "december")
			SpecialMonthName = arrMonth(intMonthNum - 1)
		Case else
			SpecialMonthName = MonthName(intMonthNum)
	End Select
End Function '--- SpecialMonthName

'------- Get Custom Week Day Name ---------------------------------------------------------------
Function SpecialWeekDayName(intDayNum, sLanguage)
	Dim arrWeekDay, sWeekDayName(), hj
	Select Case sLanguage
		Case "TR" '--- Turkish
			arrWeekDay = Array("Pazar", "Pazartesi", "Sali", "arsamba", "Persembe", "Cuma", "Cumartesi")
			For hj = 1 to 7
				Redim Preserve sWeekDayName(hj)
				sWeekDayName(hj) = arrWeekDay(hj - 1)
			Next
			SpecialWeekDayName = sWeekDayName(intDayNum)
		Case "SL" '--- Slovenian
			arrWeekDay = Array("Nedelja", "Ponedeljek", "Torek", "Sreda", "Cetrtek", "Petek", "Sobota")
			For hj = 1 to 7
				Redim Preserve sWeekDayName(hj)
				sWeekDayName(hj) = arrWeekDay(hj - 1)
			Next
			SpecialWeekDayName = sWeekDayName(intDayNum)
		Case else
			SpecialWeekDayName = WeekDayName(intDayNum)
	End Select
End Function '--- SpecialWeekDayName

'--------- Format Custom Date Time --------------------------------------------------------------
Function SpecialFormatDateTime(dsDate, sFormat)
	Dim sfDay, sfMonth
	sfDay = trim(day(dsDate))
	sfMonth = trim(month(dsDate))
	Select Case sLanguage
		Case "TR" '--- Turkish
			If sFormat = 1 OR UCase(sFormat) = "VBLONGDATE" Then
				SpecialFormatDateTime = SpecialWeekDayName(WeekDay(dsDate), sLanguage) & " " & sfDay & " " & SpecialMonthName(sfMonth, sLanguage) & " " & year(dsDate)
			Else
				SpecialFormatDateTime = sfDay & "/" & sfMonth & "/" & year(dsDate)
			End if
		Case "SL" '--- Slovenian
			If sFormat = 1 OR UCase(sFormat) = "VBLONGDATE" Then
				SpecialFormatDateTime = SpecialWeekDayName(WeekDay(dsDate), sLanguage) & " " & sfDay & " " & SpecialMonthName(sfMonth, sLanguage) & " " & year(dsDate)
			Else
				SpecialFormatDateTime = sfDay & "/" & sfMonth & "/" & year(dsDate)
			End if
		Case else
			SpecialFormatDateTime = FormatDateTime(dsDate, 1)
	End Select
End Function '--- SpecialFormatDateTime

'------- DB Date adapter Function ---------------------------------------------------------------
Private Function dataDB(varDate)
	If isDate(varDate) Then
		Dim myYear
        Dim myDay
        Dim myMonth
                vardate=CDate(varDate)
                myYear = Year(varDate)
                myDay = Day(varDate)
                myMonth = Month(varDate)
				If Len(myDay) = 1 Then myDay = "0" & myDay End if
				If Len(myMonth) = 1 Then myMonth = "0" & myMonth End if
			'--- transform date to standard DB type
			datadb = myYear & "-" & myMonth & "-" & myday
		'--- add the time if present
		If datepart("h", vardate) <> 0 OR datepart("n", vardate) <> 0 OR datepart("s", vardate) <> 0 Then
			datadb = datadb &  " " & hour(varDate) & ":" & minute(varDate) & ":" & second(varDate)
		End if
	Else
		dataDB = NULL
	End if
End Function '--- dataDB

'-------- Remove HTML from text --------------------------------------------------------------
'--- Allow users to post safe HTML to the Calendar.
'--- This function pulls out all the nasty tags that a user sholdn't
'--- use when posting HTML content using a regular expression.
'--- It also pulls out any javascript events assigned to any tags.
Private Function StripHTML(ByVal StrHTML)
	If bStripHTML Then
		Dim loRegExp	'--- Regular Expression Object (Requires vbScript 5.1 or higher)
		Dim boolErr
		'--- If no content was received, exit the function
		if VarType(StrHTML) = vbNull Then Exit function
		if StrHTML = "" Then Exit function
		On Error Resume Next
		'--- Create Regular Expression object
		Set loRegExp = New RegExp
		'--- Error handling
		If Err Then boolErr = True End If
		On Error GoTo 0
		If boolErr then 
			Err.Raise 5108, "StripHTML Function", "This function uses " & _
				"the RegExp object and requires the VBScript " & _
				"Scripting Engine Version 5.1 or higher."
			StripHTML = Null
			Exit Function
		End If
		With loRegExp
			'--- Keep finding links after the first one.				
			.Global = True
			'--- Ignore upper/lower case
			.IgnoreCase = True
			'--- Look for Script
			.Pattern = "<(/)?SCRIPT|META|STYLE([^>]*)>"
			StrHTML = .Replace(StrHTML, "<$1SCRIPT$3>")
			'--- Look for Links
			.Pattern = "<(/)?(LINK|IFRAME|FRAMESET|FRAME|APPLET|OBJECT)([^>]*)>"
			StrHTML = .Replace(StrHTML, "<$1LINK$3>")
			'--- Look for Javascript
			.Pattern = "(<A[^>]+href\s?=\s?""?javascript:)[^""]*(""[^>]+>)"
			StrHTML = .Replace(StrHTML, "$1//protected$2")
			'--- Look for IMG Javascript
			.Pattern = "(<IMG[^>]+src\s?=\s?""?javascript:)[^""]*(""[^>]+>)"
			StrHTML = .Replace(StrHTML, "$1//protected$2")
			'--- Look for Script
			.Pattern = "<([^>]*) on[^=\s]+\s?=\s?([^>]*)>"
			StrHTML = .Replace(StrHTML, "<$1$3>")
		End With
		'--- Release regular expression object
		Set loRegExp = Nothing
	End if
		StripHTML = StrHTML
End function '--- StripHTML

'-------- Execute SQL statement ------------------------------------------------------------
Private Sub ExecutesSQL(sSQL)
	On error resume next
	Set objConn = Server.CreateObject("ADODB.Connection")
		objConn.Open sCalendarDSN
			objConn.Execute(sSQL)
		objConn.Close
	Set objConn = Nothing
		'--- If an error has occured write an error to the page
		If Err.Number <> 0 Then
			Response.Write("<br />Error SQL statement " & sSQL & " cannot be executed<br />" & Err.description & "<br /><br />")
			re
		End If
	On error goto 0
End Sub

'------- Store Request.Form into array ---------------------------------------------------------------
Private Sub GetFormFields()
	Dim field, thestring, j
		For Each Field in Request.Form
			j = j + 1
			REDIM PRESERVE sFieldName(j), sFieldValue(j)
			sFieldName(j) = Field
			sFieldValue(j) = Request.Form(Field)
		Next
	If J > 0 Then iMaxFields = UBound(sFieldName) End if
End Sub

'--------- Build standard SQL DB update/add query -------------------------------------------------------
Private Sub BuildFieldUpdate()
	Dim Item, intBool, s_Date, j
	For j = 1 to iMaxFields
		For each Item in RS.Fields
			If lcase(Item.name) = lcase(sFieldName(j)) Then
				Select Case Item.Type

				   Case 3, 19, 20, 21 '"adInteger, adUnsignedInt, adBigInt, adUnsignedBigInt"
							upstring = upstring & ", " & sFieldName(j) & " = " & SQL_numeric(sFieldValue(j))
							upValues = upValues & ", " & SQL_numeric(sFieldValue(j))
							upFields = upFields & ", " & Item.name

					Case 6 '"adCurrency"
						upstring = upstring & ", " & sFieldName(j) & " = " & SQL_currency(sFieldValue(j), 0, DbType)
						upValues = upValues & ", " & SQL_currency(sFieldValue(j), 0, DbType)
						upFields = upFields & ", " & Item.name

					Case 11, 16, 17  '"adBoolean", "adTinyInt", "adUnsignedTinyInt"
						upstring = upstring & ", " & sFieldName(j) & " = " & SQL_boolean(sFieldValue(j), 0, DbType)
						upValues = upValues & ", " & SQL_boolean(sFieldValue(j), 0, DbType)
						upFields = upFields & ", " & Item.name

					Case 7, 133, 134, 135 '"adDate", "adDBDate", adDbTime", "adDbTimeStamp"
						If IsDate(sFieldValue(j)) Then
							if LCase(dbType) = "mssql" Then
								upstring = upstring & ", " & sFieldName(j) & " = CONVERT(DATETIME, '" & Replace(DataDB(sFieldValue(j)), "-", "") & "', 112)"
								upValues = upValues & ", CONVERT(DATETIME, '" & Replace(DataDB(sFieldValue(j)), "-", "") & "', 112)"
								upFields = upFields & ", " & Item.name
							Else
								upstring = upstring & ", " & sFieldName(j) & " = " & SQL_date(dataDB(sFieldValue(j)), DbType)
								upValues = upValues & ", " & SQL_date(dataDB(sFieldValue(j)), DbType)
								upFields = upFields & ", " & Item.name
							End if
						End if

					Case Else
						If Len(sFieldValue(j)) > 0 Then
							upstring = upstring & ", " & sFieldName(j) & " = " & SQL_string(Cstr(StripHTML(sFieldValue(j))), 0, DbType)
							upValues = upValues & ", " & SQL_string(Cstr(StripHTML(sFieldValue(j))), 0, DbType)
							upFields = upFields & ", " & Item.name
						End if

			   End Select
			End if
		Next
	Next
	if instr(upstring, ",") > 0 Then upString = Right(upString , len(upstring) - 1)
	if instr(upFields, ",") > 0 Then upFields = Right(upFields , len(upFields) - 1)
	if instr(upValues, ",") > 0 Then upValues = Right(upValues , len(upValues) - 1)
	If Err.number <> 0 Then
	  Session("msg") = "&nbsp;<img src=""" & strimgDir & "warning.gif"" width='12' height='11' border='0' alt="""" align=absmiddle>&nbsp;<b style=""color:red;font-size:10px;"">ERROR</b> : " & Err.description
	End if
End Sub '--- BuildFieldUpdate

 '---------- Prepare strings for SQL -----------------------------
Public Function SQL_string(ByVal asExpression, ByRef anMaxLength, ByRef DbType)
	'--- If maximum length is defined
	If anMaxLength > 0 Then
		'--- Trim expression to maximum length
		asExpression = Left(asExpression, anMaxLength)
	End If '--- anMaxLength > 0
	'--- Double quote SQL quote characters
	asExpression = Replace(asExpression, "'", "''")
	'--- If Expression is Empty
	If asExpression = "" Then
		'--- Return a NULL value
		SQL_string = "NULL"
	'--- Else expression is not empty
	Else
		'--- Return quoted expression
		SQL_string = "'" & CStr(asExpression) & "'"
	End If '--- asExpression
End Function '--- SQL_string

'----------- Prepare numerics for SQL -----------------------------
Public Function SQL_numeric(ByVal anExpression)
	'--- If expression numeric
	If IsNumeric(anExpression) And Not anExpression = "" Then
		'--- Return number
		SQL_numeric = anExpression
	'--- Else expression not numeric
	Else
		'--- Return NULL
		SQL_numeric = "NULL"
	End If '--- IsNumeric(anExpression) And Not anExpression = ""
End Function '--- SQL_numeric

'----------- Prepare booleans for SQL -----------------------------
Public Function SQL_boolean(ByVal abExpression, ByRef abDefault, ByRef DbType)
	'--- Declare Database Constants
	Dim lbTrue, lbFalse
	If LCASE(dbType) = "access" Then
		lbTRUE = -1  '--- (-1 = Access)
	Else
		lbTRUE = 1 '--- (1 = SQL)
	End if
		lbFALSE = 0
	Dim lbResult '--- Result to be passed back
	'--- Prepare for any errors that may occur
	On Error Resume Next
	'--- If expression not provided
	If abExpression = "" Then
		'--- Set expression to default value
		abExpression = abDefault
	End If '--- abExpression = ""
	'--- Attempt to convert expression
	lbResult = CBool(abExpression)
	'--- If Err Occured
	If Err Then
		'--- Clear the error
		Err.Clear
		'--- Determine action based on Expression
		Select Case LCase(abExpression)
			'--- True expressions
			Case "yes", "on", "true", "True", "-1", "1"
				lbResult = True
			'--- False expressions
			Case "no", "off", "false", "False", "0"
				lbResult = False
			'--- Unknown expression
			Case Else
				lbResult = abDefault
		End Select '--- LCase(abExpression)
	End If '--- Err
	'--- If result is True
	If lbResult Then
		'--- Return True
		SQL_boolean = lbTRUE
	'--- Else Result is false
	Else
		'--- Return False
		SQL_boolean = lbFALSE
	End If '--- lbResult
End Function '--- SQL_boolean

'---------- Prepare dates for SQL ------------------------------
Public Function SQL_date(ByRef adExpression, ByRef DbType)
	'--- If Expression valid date
	If IsDate(adExpression) Then
		'--- Return Date
		If LCASE(dbType) = "access" Then
			SQL_date = "#" & adExpression & "#" ' Access Database
'		Elseif LCASE(dbType) = "mssql" Then
'	   		SQL_date = "CONVERT(DATETIME, '" & Replace(DataDB(adExpression), "-", "") & "', 112)" ' SQL Database
		Else
			SQL_date = "'" & adExpression & "'" ' SQL Database
		End if
	'--- Else Expression not valid date
	Else
		'--- Return NULL
		SQL_date = "NULL"
	End If '--- IsDate(adExpression)
End Function '--- SQL_date

'---------- Prepare currency for SQL ------------------------------
Public Function SQL_currency(ByVal acExpression)
	'--- If Empty Expression
	If acExpression = "" Then
		'--- Return Null
		SQL_currency = "NULL"
	'--- Else expression has content
	Else
		'--- Prepare for Errors
		On Error Resume Next
		'--- Attempt to convert expression to currency
		SQL_currency = CCur(acExpression)
		'--- If error occured
		If Err Then
			'--- Clear Error
			Err.Clear
			SQL_currency = "NULL"
		End If '--- Err
	End If '--- acExpression = ""
End Function '--- SQL_currency

  '-------- External WYSIWYG Editor management --------------------------------
	Sub ExternalEditor()
		W "<script type=""text/javascript"" src=""" &sEXTEditorDir & "fckeditor.js""></script>"
		W "<script type=""text/javascript"">"
			W "<!-- //"
			W "function FCKeditor_OnComplete( editorInstance ){"
				W "editorInstance.Events.AttachEvent( 'OnBlur'	, FCKeditor_OnBlur ) ;"
				W "editorInstance.Events.AttachEvent( 'OnFocus', FCKeditor_OnFocus ) ;}"
			W "function FCKeditor_OnBlur( editorInstance ){"
				W "editorInstance.ToolbarSet.Collapse() ;}"
			W "function FCKeditor_OnFocus( editorInstance ){"
				W "editorInstance.ToolbarSet.Expand() ;}"
			W "var oFCKeditor = new FCKeditor( 'EVENT_DETAILS' ) ;"
			W "if ( document.all )"
				W "oFCKeditor.Config['ToolbarStartExpanded'] = false ;"
			W "oFCKeditor.BasePath = """ & sEXTEditorDir & """ ;"
			W "oFCKeditor.Config['SkinPath'] = " & sEXTEditorDir & " + 'editor/skins/office2003/' ;"
			W "oFCKeditor.ReplaceTextarea() ;"
		  W "// -->"
		W "</script>"
	End Sub
	'-------------------------------------------------------------------------------------
%>